<template>
  <div class="bg-[#fff]">
    <a-page-header style="border: 1px solid rgb(235, 237, 240)" @back="router.go(-1)">
      <template #backIcon>
        <div><a-button type="primary">返回</a-button></div>
      </template>
      <template #title>
        <div></div>
      </template>
    </a-page-header>
    <a-collapse v-model:activeKey="activeKey" :bordered="false">
      <a-collapse-panel key="1" header="地块信息" :forceRender="true">
        <DkTable :data="dsInfor.wrdkjbxxb" />
      </a-collapse-panel>

      <a-collapse-panel key="2" header="修复效果评估报告基本信息" :forceRender="true">
        <suBainForm
          ref="chilrenReport"
          labelFirst="效果评估"
          :obj="[{ name: '修复效果评估报告' }, { name: '修复效果评估报告编制' }]"
          :data="dsInfor.xgpg"
        />
        <template #extra><a-button type="primary" @click.prevent="saveReport($event)">保存</a-button></template>
      </a-collapse-panel>

      <a-collapse-panel header="修复方案编制单位基本信息" :forceRender="true" v-for="(item, index) in unitMessageFormList" :key="index + 4">
        <unitMessageForm :ref="(el) => childRef(el, index)" :data="item" />
        <template #extra>
          <a-button type="primary" @click.prevent="addUnitMessageFormList($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="delMessageFormList($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="suBainFormAddEdit($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel header="修复效果评估样品分析检测单位基本信息" :forceRender="true" v-for="(item, index) in jcpgunitList" :key="index + 5">
        <unitMessageForm
          :ref="(el) => childjcRef(el, index)"
          :upload="index + 1"
          :dkxx="{ wrdkid: dsInfor.wrdkjbxxb.wrdkid, scjdbm: 'S6' }"
          :data="item"
        />
        <template #extra>
          <a-button type="primary" @click.prevent="addjcpgunitList($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="deljcpgunitList($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="sujcpgunitListt($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel header="修复措施信息" :forceRender="true" key="140000">
        <ControlInformation
          labelFirst="修复效果评估"
          ref="chilrenGkcs"
          :obj="[{ name: '开展修复土壤面积' }, { name: '修复土壤方量' }]"
          :data="dsInfor.xgpg"
        />
        <template #extra><a-button type="primary" @click.prevent="addGKcs($event)">保存</a-button></template>
      </a-collapse-panel>
      <a-collapse-panel header="修复文件上传" :forceRender="true" key="150000">
        <CdUpload labelFirst="效果评估" :objec="[{ name: '公示截图' }, { name: '修复方案' }]" :data="dsInfor.xgpg" />
      </a-collapse-panel>
      <a-collapse-panel header="填报进度" :forceRender="true" key="160000">
        <fillProgress :List="dsInfor?.lzjd"></fillProgress>
      </a-collapse-panel>
    </a-collapse>
  </div>
</template>
<script lang="ts" setup>
  import { ref } from 'vue';
  import { useMessage } from '/@/hooks/web/useMessage';
  import DkTable from '/@/components/customComponent/DkTable.vue';
  import suBainForm from '/@/components/customComponent/gkpg/pgReport.vue';
  import ControlInformation from '/@/components/customComponent/gkpg/csInfor.vue';
  import unitMessageForm from '/@/components/customComponent/unitMessageForm.vue';
  import fillProgress from '/@/components/customComponent/fillProgress.vue';
  import CdUpload from '/@/components/customComponent/CdUpload.vue';
  import { plotDetails, updateBzdw, updateJcdw, delBzdw, delJcdw, saveXgpg } from '/@/api/common/api';
  import { useRouter } from 'vue-router';
  import { nextTick } from 'vue';

  let router = useRouter();
  const { createMessage } = useMessage();
  const saveFlg = ref(true);
  const param = ref(router.currentRoute.value.query);
  let unitMessageFormList = ref([{ id: null }]);
  let jcpgunitList = ref([{ id: null }]);
  // 获取地块信息
  const dsInfor = ref<any>({
    jcdw: [],
    bzdw: [],
    cbdc: {},
    xxdc: {},
    wrdkjbxxb: {},
  });

  async function getdkInfor() {
    dsInfor.value = await plotDetails({
      wrdkid: param.value.wrdkid,
      id: param.value.id,
      scjdbm: 'S6',
      pgtype: param.value.pgtype,
    });
    saveFlg.value = true;
    unitMessageFormList.value = dsInfor.value.bzdw;
    jcpgunitList.value = dsInfor.value.jcdw;

    if (unitMessageFormList.value.length == 0) unitMessageFormList.value.push({ id: null });

    if (jcpgunitList.value.length == 0) jcpgunitList.value.push({ id: null });
  }
  getdkInfor();

  const activeKey = ref(['1', '2', '3', '4', '5', '6', '7', '140000', '150000', '160000']);

  // 风险管控基本方案
  const chilrenReport = ref<any>(null);
  async function saveReport(event) {
    event.stopPropagation();
    const res = await chilrenReport?.value.getFormValueFxpg();
    if (res.gkfs == 1) {
      if (!res.gswz) {
        createMessage.warn('请填写网址');
        return;
      }
    }
    await saveXgpg(res);
  }
  // 修复措施
  const chilrenGkcs = ref<any>(null);
  async function addGKcs(event) {
    event.stopPropagation();
    const res = await chilrenGkcs?.value.getFormValueFxpg();
    if(res.sjxffw > dsInfor.value.wrdkjbxxb.zdmj){
        createMessage.warn('开展修复土壤面积不能超过地块占地面积');
        return false
    }
    await saveXgpg(res);
  }
  // 编制单位开始
  const childrenBzd = ref<any>([]);
  const childRef = (el, index) => {
    if (el) childrenBzd.value[index] = el;
  };
  const callChildMethod = (index) => {
    childrenBzd.value[index].getFormValueBz();
  };
  function addUnitMessageFormList(event) {
    event.stopPropagation();
    unitMessageFormList.value.unshift({ id: null });
    nextTick(() => {
      callChildMethod(unitMessageFormList.value.length - 1);
    });
  }
  async function delMessageFormList(event, index) {
    event.stopPropagation();
    if (unitMessageFormList.value[index].id) {
      await delBzdw({ id: unitMessageFormList.value[index].id });
    }
    unitMessageFormList.value.splice(index, 1);
    childrenBzd.value.splice(index, 1);
    // getdkInfor();
  }
  async function suBainFormAddEdit(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenBzd.value[index].getFormValueBz();
        res.wthtje = String(res.wthtje);
        res.scjdbm = 'S6';
        res.pgtype = param.value.pgtype;
        res.jgtype = 'bzdw';
        // 新增的时候没有这个值
        res.wrdkid = param.value.wrdkid;
        const id = await updateBzdw(res);
        if (id != '成功') {
          unitMessageFormList.value[index] = res;
          unitMessageFormList.value[index].id = id;
        }
        saveFlg.value = true;
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
  // 编制单位结束
  // 修复效果评估样品分析检测单位基本信息
  const childrenfxBzd = ref<any>([]);
  const childjcRef = (el, index) => {
    if (el) childrenfxBzd.value[index] = el;
  };
  const callChildFxMethod = (index) => {
    childrenfxBzd.value[index].getFormValueBz();
  };
  function addjcpgunitList(event) {
    event.stopPropagation();
    jcpgunitList.value.unshift({ id: null });
    nextTick(() => {
      callChildFxMethod(jcpgunitList.value.length - 1);
    });
  }
  async function deljcpgunitList(event, index) {
    event.stopPropagation();
    if (jcpgunitList.value[index].id) {
      await delJcdw({ id: jcpgunitList.value[index].id });
    }
    jcpgunitList.value.splice(index, 1);
    childrenfxBzd.value.splice(index, 1);
    // getdkInfor();
  }
  async function sujcpgunitListt(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenfxBzd.value[index].getFormValueBz();
        res.wthtje = String(res.wthtje);
        res.scjdbm = 'S6';
        res.pgtype = param.value.pgtype;
        res.wrdkid = param.value.wrdkid;
        res.jgtype = 'jcdw';
        const id = await updateJcdw(res);
        if (id != '成功') {
          jcpgunitList.value[index] = res;
          jcpgunitList.value[index].id = id;
        }
        saveFlg.value = true;
        // getdkInfor();
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
  // 修复效果评估样品分析检测单位基本信息
</script>

<style lang="less" scoped>
  :deep(.ant-collapse-borderless) {
    width: 100%;
  }
</style>
